/** ݒϐ
 */
/*
 * Copyright (c) 2000-2005, 2007 shimitei
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef	ifmmainH
#define	ifmmainH

#include "critsect.h"
#include "ifmmedia.h"

extern void __fastcall getSusieCompatiAppName(TStringList* AppList) ;
extern HICON __fastcall getIconHandle(const char *filename, const DWORD filetype, DWORD flag) ;
extern bool __fastcall matchesExt(const AnsiString &filename, char *ext) ;

enum EIfmmOption
{
	OPTION_MemoryPlay,	// ͎Đ
	OPTION_ReturnErr,		// 킴ƃG[Ԃ
	OPTION_StayOnTop,		// EBhEɑOʂ
	OPTION_NoActive,		// EBhEANeBu
	OPTION_WindowPos,		// EBhEʒuŒ
	OPTION_WindowPosX,	// v[[̈ʒu
	OPTION_WindowPosY,	// v[[̈ʒu
	OPTION_Minimized,		// EBhEŏŋN
	OPTION_PreviewMovie,// vr[
	OPTION_PreviewPos1,	// vr[ʒu
	OPTION_PreviewPos2,	// vr[ʒu
	OPTION_MovieCenter,	// 𒆉ɕ\
	OPTION_MovieSize,		// ̃TCY{
	OPTION_MoviePosX,		// v[[̈ʒu
	OPTION_MoviePosY,		// v[[̈ʒu
	OPTION_MovieHeight,	// ̃JX^TCY
	OPTION_MovieWidth,	// ̃JX^TCY
	OPTION_DebugMode,		// t@C`FbNȂōĐ݂
	OPTION_SusieOnly,		// SusieȊO̎gps
	OPTION_IsSusie,			// ĂяoSusieH
	OPTION_PlayByViX,		// ViXŃvr[݂̂𗘗pIvVBGetPictureŃG[ԂB
	OPTION_IsViX,				// ĂяoViXH
	OPTION_COUNT,
} ;
enum EIfmmPlayType
{
	WAVEPLAY,
	MIDIPLAY,
	AVIPLAY,
	AIFFPLAY,
	MOVPLAY,
	MPEGPLAY,
	MPAPLAY,
	AUPLAY,
	OGGPLAY,
	RMPLAY,
	USERPLAY,
} ;
typedef struct
{
	/* IvVݒ */
	DWORD option[ OPTION_COUNT ] ;

	/* T|[g` */
	bool playable[ FILETYPE_COUNT ] ;
} IFMMVAR_STRUCT ;

class TPluginVar
{
public:
  TPluginVar() {} ;
  ~TPluginVar() {} ;

  DWORD getOption(DWORD id)
  {
    TCriticalSection cs ;
    return m_var.option[ id ] ;
  }

  void getPreviewPos(double *pd)
  {
    TCriticalSection cs ;
    pd[0] = m_var.option[ OPTION_PreviewPos1 ] ;
		pd[1] = m_var.option[ OPTION_PreviewPos2 ] ;
	}

	void getPlayableTable(bool *pb)
	{
		TCriticalSection cs ;
		for (int i=0; i < FILETYPE_COUNT; i++)
		{
				pb[i] = m_var.playable[i] ;
    }
  }

  void set(IFMMVAR_STRUCT *ps, const AnsiString &userDefExt)
  {
    TCriticalSection cs ;
    m_var = *ps ;
    m_userDefExt = userDefExt ;
  }

  void get(IFMMVAR_STRUCT *ps, AnsiString &userDefExt)
  {
    TCriticalSection cs ;
    *ps = m_var ;
		userDefExt = m_userDefExt ;
	}

	void getVar(IFMMVAR_STRUCT *ps)
	{
		TCriticalSection cs ;
		*ps = m_var ;
	}

	void setUserDefExt(const AnsiString &userDefExt)
	{
		TCriticalSection cs ;
		m_userDefExt = userDefExt ;
	}

	char* getUserDefExt(void)
	{
		TCriticalSection cs ;
    return m_userDefExt.c_str() ;
  }

private:
	IFMMVAR_STRUCT m_var ;
  AnsiString m_userDefExt ;
} ;
extern TPluginVar g_var ; /* O[o */

#endif /* ifmmainH */

